#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityNationalDayMission.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityNationalDayMission> M_ActivityNationalDayMission::msSingleton(nullptr);

int M_ActivityNationalDayMission::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityNationalDayMissionData* M_ActivityNationalDayMission::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityNationalDayMissionData>& M_ActivityNationalDayMission::GetMapData()
{
	return mMapData;
}

void M_ActivityNationalDayMission::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityNationalDayMission::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityNationalDayMissionData data;
		data.mID = element->IntAttribute("ID");
		data.mCompleteType = element->IntAttribute("CompleteType");
		data.mTaskName = element->Attribute("TaskName");
		data.mTaskDescription = element->Attribute("TaskDescription");
		data.mTheBranchLine = element->IntAttribute("TheBranchLine");
		data.mStage = element->IntAttribute("Stage");
		data.mCompleteCount = element->IntAttribute("CompleteCount");
		{
			const char* AwardItemIDs = element->Attribute("AwardItemIDs");
			std::vector<std::string> vecAwardItemIDs;
			boost::split(vecAwardItemIDs, AwardItemIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemIDs[i].c_str(), &temp))
				{
					data.mAwardItemIDs.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		data.mTaskIcon = element->Attribute("TaskIcon");
		data.mSecondaryInterfaceICON = element->Attribute("SecondaryInterfaceICON");
		data.mTaskStar = element->IntAttribute("TaskStar");
		data.mTaskLimits = element->IntAttribute("TaskLimits");
		data.mCompleteParam = element->IntAttribute("CompleteParam");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityNationalDayMission::Load()
{
	Load("../Config/M_ActivityNationalDayMission.xml");
}

M_ActivityNationalDayMission* M_ActivityNationalDayMission::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityNationalDayMission());
	}
	return msSingleton.get();
}
